// Agent officerB in project election-borda

/* Initial beliefs and rules */

winner(W) :- ballots(B) & borda(B,R) & .max(R,count(_,W)).

borda(B,R) :- candidates(C) & .length(C,N) & borda_count(B,[],N,R).

borda_count([],R,_,R).
borda_count([V|T],I,N,R) :- count_vote(V,I,1,N,J) & borda_count(T,J,N,R).

count_vote([],R,_,_,R).
count_vote([C|T],L,X,Y,R) :- .member(count(Z,C),L) & .delete(count(Z,C),L,L1) & count_vote(T,[count(Z+(Y-X),C)|L1],X+1,Y,R).
count_vote([C|T],L,X,Y,R) :- count_vote(T,[count((Y-X),C)|L],X+1,Y,R).
 

/* Initial goals */

/* Plans */

+!open <- open([candidate1,candidate2,candidate3],[person1,person2]).
+!close <- .wait(1000); close; !declare_winner.

+!declare_winner: winner(W) <- .print("Winner is ",W); .send(W,tell,winner(election2019)).


{ include("$jacamoJar/templates/common-cartago.asl") }
{ include("$jacamoJar/templates/common-moise.asl") }

// uncomment the include below to have a agent that always complies with its organization  
{ include("$jacamoJar/templates/org-obedient.asl") }
