// CArtAgO artifact code for project election-borda

package tools;

import java.util.List;
import java.util.ArrayList;

import cartago.*;
import jason.asSyntax.ASSyntax;
import jason.asSyntax.ListTerm;
import jason.asSyntax.parser.ParseException;

public class BallotBox extends Artifact {

	List<String> voters;
	List<Object[]> result = new ArrayList<Object[]>();

    public void init() {
        defineObsProperty("status", "closed");
    }

	@OPERATION public void open(Object[] candidates, Object[] voters) {
        this.voters  = new ArrayList<String>();

		ListTerm cs = ASSyntax.createList();
		for (Object o: candidates)
			try {
				cs.add(ASSyntax.parseTerm(o.toString()));
			} catch (ParseException e) {
				e.printStackTrace();
			}
		for (Object o: voters)
			this.voters.add(o.toString());

		defineObsProperty("candidates", cs);
        getObsProperty("status").updateValue("open");

	}

    /* Write the "vote" Operation here...
       it should fail (method failed("...")) if the status is "closed"
       or if the person voted already (attempting to remove the agent name
       (method getCurrentOpAgentId().getAgentName()) returns false)
       otherwise it should add the vote to the result variable */

    @OPERATION void close() {
		ListTerm final_result = ASSyntax.createList();
		for (Object[] i: result) {
			ListTerm l = ASSyntax.createList();
			for (Object j : i) {
				try {	
					l.add(ASSyntax.parseTerm(j.toString()));
				} catch (ParseException e) {
					e.printStackTrace();
				}
			}
			final_result.add(l);
		}
        getObsProperty("status").updateValue("closed");
		defineObsProperty("ballots", final_result);
	}

}
